<?php


//---------------------------
//-----  2008-Jul-02 code ---
//---------------------------

if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );

/**
*
* @version $Id: ps_nbepay.php 617 2007-01-04 19:43:08Z soeren_nb $
* @package VirtueMart
* @subpackage payment
* @copyright Copyright (C) 2004-2005 Soeren Eberhardt. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* VirtueMart is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.
*
* http://virtuemart.net
*/

class ps_nbepay {

    var $payment_code = "NBEPAY";
    var $classname    = "ps_nbepay";
   
    /**
    * Show all configuration parameters for this payment method
    * @returns boolean False when the Payment method has no configration
    */
    function show_configuration() {
        global $VM_LANG;

        $database = new ps_DB();

        /** Read current Configuration ***/
        require_once(CLASSPATH ."payment/".$this->classname.".cfg.php");

        ?>
      <table>
        <tr>
            <td><strong>NBepay  Merchant ID</strong></td>	<!-- installation title -->
            <td>
                <input type="text" name="NBEPAY_LOGIN" class="inputbox" value="<?php echo NBEPAY_LOGIN ?>" />
            </td>
            <td>Your NBepay Merchant id		<!-- installation detail -->
            </td>
        </tr>
        <tr>
            <td><strong>NBepay Secret Word / Verify Key </strong></td>
            <td>
                <input type="text" name="NBEPAY_SECRETWORD" class="inputbox" value="<?php echo NBEPAY_SECRETWORD ?>" />
            </td>
            <td>Your Verify Key for NBepay. Makes the transactions more secure.
            </td>
        </tr>
        <tr>
        <tr>
            <td><strong>NBepay Multiple Return URL</strong></td>
            <td>
                <input type="text" name="NBEPAY_MULURL" class="inputbox" value="<?php echo NBEPAY_MULURL ?>" />
            </td>
            <td>Provide complete URL if u wish to have Multiple Return URL for NBePay Module.<br>(E.g : http://www.yourdomain.com.my/returnurl.php).&nbsp;Keep the field blank if you dont want to have this feature.
            </td>
        </tr>
        <tr>
            <td><strong>Order Status for successful transactions</strong></td>
            <td>
                <select name="NBEPAY_VERIFIED_STATUS" class="inputbox" >
                <?php
                    $q = "SELECT order_status_name,order_status_code FROM #__{vm}_order_status ORDER BY list_order";

                    $database->query($q);
                    $rows = $database->record;
                    $order_status_code = Array();
                    $order_status_name = Array();
                    
                    foreach( $rows as $row ) {
                      $order_status_code[] = $row->order_status_code;
                      $order_status_name[] =  $row->order_status_name;
                    }
                    for ($i = 0; $i < sizeof($order_status_code); $i++) {
                      echo "<option value=\"" . $order_status_code[$i];
                      if (NBEPAY_VERIFIED_STATUS == $order_status_code[$i]) 
                         echo "\" selected=\"selected\">";
                      else
                         echo "\">";
                      echo $order_status_name[$i] . "</option>\n";
                    }?>
                    </select>
            </td>
            <td> Select the order status to which the actual order is set, if the NBepay transaction was successful. 
                 If using download selling options: select the status which enables the download 
                 (then the customer is instantly notified about the download via e-mail). 
            </td>
        </tr>
            <tr>
            <td><strong>Order Status for failed transactions</strong></td>
            <td>
                <select name="NBEPAY_INVALID_STATUS" class="inputbox" >
                <?php
                    for ($i = 0; $i < sizeof($order_status_code); $i++) {
                      echo "<option value=\"" . $order_status_code[$i];
                      if (NBEPAY_INVALID_STATUS == $order_status_code[$i]) 
                         echo "\" selected=\"selected\">";
                      else
                         echo "\">";
                      echo $order_status_name[$i] . "</option>\n";
                    } ?>
                    </select>
            </td>
            <td>Select an order status for failed NBepay transactions. 
            </td>
        </tr>
        <tr>
            <td><strong>Merchant Notifications</strong></td>
            <td>
                <select name="NBEPAY_MERCHANT_EMAIL" class="inputbox" >
                  <option <?php if (NBEPAY_MERCHANT_EMAIL == 'True') echo "selected=\"selected\""; ?> value="True">Yes</option>
                  <option <?php if (NBEPAY_MERCHANT_EMAIL == 'False') echo "selected=\"selected\""; ?> value="False">No</option>
                </select>
            </td>
            <td>Should NBepay e-mail a receipt to the store owner?
            </td>
        </tr>
        <tr>
            <td><strong>Merchant Email</strong></td>
            <td><input type="text" name="NBEPAY_MERCHANT_EMAILTO" class="inputbox" value="<?php echo NBEPAY_MERCHANT_EMAILTO ?>" /></td>
            <td>Which email account will receive the notifications ?</td>
        </tr>
      </table>
   <?php


/**        <table>
          <tr>
          <td><strong>NBePay Merchant ID</strong></td>
              <td>
                  <input type="text" name="NBEPAY_INST_ID" class="inputbox" value="<?php echo NBEPAY_INST_ID ?>" />
              </td>
              <td>The "Merchant ID", you've got from NBePay.
              </td>
          </tr>
        </table>
***/
    }

    function has_configuration() {
      // return false if there's no configuration
      return true;
   }

        /**
        * Returns the "is_writeable" status of the configuration file
        * @param void
        * @returns boolean True when the configuration file is writeable, false when not
        */
   function configfile_writeable() {
      return is_writeable( CLASSPATH."payment/".$this->classname.".cfg.php" );
   }
       /**
        * Returns the "is_readable" status of the configuration file
        * @param void
        * @returns boolean True when the configuration file is writeable, false when not
        */
   function configfile_readable() {
      return is_readable( CLASSPATH."payment/".$this->classname.".cfg.php" );
   }

      /**
        * Writes the configuration file for this payment method
        * @param array An array of objects
        * @returns boolean True when writing was successful
        */
   function write_configuration( &$d ) {

      $my_config_array = array( "NBEPAY_LOGIN"           => $d['NBEPAY_LOGIN'],
                                "NBEPAY_SECRETWORD"      => $d['NBEPAY_SECRETWORD'],
                                "NBEPAY_MULURL"		 => $d['NBEPAY_MULURL'],
                                "NBEPAY_VERIFIED_STATUS" => $d['NBEPAY_VERIFIED_STATUS'],
                                "NBEPAY_INVALID_STATUS"  => $d['NBEPAY_INVALID_STATUS'],
                                "NBEPAY_MERCHANT_EMAIL"  => $d['NBEPAY_MERCHANT_EMAIL'],
                                "NBEPAY_MERCHANT_EMAILTO"=> $d['NBEPAY_MERCHANT_EMAILTO']
                              );
                             
      $config = "<?php\n";
      $config .= "if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' ); \n\n";
      foreach( $my_config_array as $key => $value ) {  $config .= "define ('$key', '$value');\n";  }

      $config .= "?>";

      if ($fp = fopen(CLASSPATH ."payment/".$this->classname.".cfg.php", "w")) {

             fputs($fp, $config, strlen($config));
             fclose ($fp);
             return true;
      }else             return false;

   }

  /**************************************************************************
   ** name: process_payment()
   ** returns:
   ***************************************************************************/
   function process_payment($order_number, $order_total, &$d) {
        return true;
    }

}


